<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ page import="edu.uclm.esi.mongo.isotel.dominio.*, edu.uclm.esi.mongo.isotel.auxiliares.*, 
		edu.uclm.esi.mongo.isotel.persistencia.*, java.util.*" %>
<%@ page errorPage="error.jsp" %>		

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>MongoTel - Empresa telefónica</title>

<%
	String sIdCliente=request.getParameter("idCliente");
	String dni=request.getParameter("dni");
	String nombre=request.getParameter("nombre");
	String apellido1=request.getParameter("apellido1");
	String apellido2=request.getParameter("apellido2");

	Cliente cliente=DAOCliente.findCliente(sIdCliente, dni, nombre, apellido1, apellido2);
	session.setAttribute("cliente", cliente);
%>

</head>
<body>
	<h1>MongoTel - Empresa telefónica - Ficha de cliente</h1>
	<a href="index.jsp"><i>Ir al principio</i></a>
		
	<form>
		Id de cliente: <input type="text" id="idCliente" value="<%= cliente.getId() %>" readonly="readonly"><br>
		DNI: <input type="text" id="dni" value="<%= cliente.getDNI() %>" readonly="readonly"><br>
		Teléfono: <input type="text" id="telefono" value="<%= cliente.getTelefono() %>" readonly="readonly"><br>
		Nombre: <input type="text" id="nombre" value="<%= cliente.getNombre() %>" readonly="readonly"><br>
		Apellido 1: <input type="text" id="apellido1" value="<%= cliente.getApellido1() %>" readonly="readonly"><br>
		Apellido 2: <input type="text" id="apellido2" value="<%= cliente.getApellido2() %>" readonly="readonly"><br>
		Fecha de nacimiento: <input type="date" id="fechaDeNacimiento" value="<%= Fechas.sinHoraYMD(cliente.getFechaDeNacimiento()) %>" readonly="readonly"><br>
		Tarifa: 
		<% String tarifa=cliente.getTarifa().getClass().getSimpleName(); %>
		<select id="tarifa">
			<option value="TarifaPlana" <%= tarifa.equals("TarifaPlana") ? "selected='selected'" : ""%>>Tarifa plana</option>
			<option value="Tarifa50Minutos" <%= tarifa.equals("Tarifa50Minutos") ? "selected='selected'" : ""%>>Tarifa 50 minutos</option>
			<option value="TarifaTardes" <%= tarifa.equals("TarifaTardes") ? "selected='selected'" : ""%>>Tarifa de tardes</option>
			<option value="TarifaFinDeSemana" <%= tarifa.equals("TarifaFinDeSemana") ? "selected='selected'" : ""%>>Tarifa de fin de semana</option>
		</select><br>
		
		<button type="button" id="guardar" onclick="guardarDatos()" style="display:none">Guardar cambios</button>
		<button type="button" id="modificar" onclick="habilitar()">Modificar datos</button>
		<button type="button" id="eliminar" onclick="eliminarCliente()">Eliminar cliente y sus llamadas</button>
		<a href="verLlamadas.jsp?idCliente=<%= cliente.getId() %>">Ver llamadas</a>
	</form>
	
	<script>
	function habilitar() {
		document.getElementById("dni").removeAttribute("readonly");
		document.getElementById("nombre").removeAttribute("readonly");
		document.getElementById("apellido1").removeAttribute("readonly");
		document.getElementById("apellido2").removeAttribute("readonly");
		document.getElementById("fechaDeNacimiento").removeAttribute("readonly");
		document.getElementById("modificar").setAttribute("style", "display:none");
		document.getElementById("guardar").setAttribute("style", "display:visible");
	}
	
	function deshabilitar() {
		document.getElementById("dni").setAttribute("readonly", "readonly");
		document.getElementById("nombre").setAttribute("readonly", "readonly");
		document.getElementById("apellido1").setAttribute("readonly", "readonly");
		document.getElementById("apellido2").setAttribute("readonly", "readonly");
		document.getElementById("fechaDeNacimiento").removeAttribute("readonly");
		document.getElementById("modificar").setAttribute("style", "display:visible");
		document.getElementById("guardar").setAttribute("style", "display:none");
	}
	
	function eliminarCliente() {
		var request=new XMLHttpRequest();
		request.open("POST", "eliminarCliente.jsp");
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.onreadystatechange=function() {
			if (request.readyState==4) {
				if (request.status==200) {
					var respuesta=request.responseText;
					respuesta=JSON.parse(respuesta);
					if (respuesta.resultado=="OK") {
						var clienteEliminado=respuesta.clientesEliminados;
						if (clienteEliminado==0)
							alert("No se ha borrado al cliente");
						else {
							alert("Se ha borrado " + clienteEliminado + " cliente(s) y " +
									respuesta.llamadasEliminadas + " llamadas");
						}
					} else {
						alert(respuesta.resultado);
					}
				} else {
					alert("Error: " + request.statusText);
				}
			}
		};
		var pars="idCliente=" + document.getElementById("idCliente").value;
		request.send(pars);
	}
	
	function guardarDatos() {
		var request=new XMLHttpRequest();
		request.open("POST", "actualizarCliente.jsp");
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.onreadystatechange=function() {
			if (request.readyState==4) {
				if (request.status==200) {
					var respuesta=request.responseText;
					respuesta=JSON.parse(respuesta);
					if (respuesta.resultado=="OK") {
						deshabilitar();
						alert("Cambios guardados");
					} else {
						alert(respuesta.resultado);
					}
				} else {
					alert("Error: " + request.statusText);
				}
			}
		};
		var pars="idCliente=" + document.getElementById("idCliente").value +
				"&dni=" + document.getElementById("dni").value +
				"&nombre=" + document.getElementById("nombre").value +
				"&apellido1=" + document.getElementById("apellido1").value +
				"&apellido2=" + document.getElementById("apellido2").value +
				"&fechaDeNacimiento=" + document.getElementById("fechaDeNacimiento").value +
				"&tarifa=" + document.getElementById("tarifa").value;
		request.send(pars);
	}
	</script>
</body>
</html>