package edu.uclm.esi.mongo.etiquetasMongo;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;
import java.util.GregorianCalendar;

import org.bson.BsonDateTime;
import org.bson.BsonDocument;
import org.bson.BsonInt32;
import org.bson.BsonString;

public class Bsoneador {

	public static BsonDocument getBsonDocument(Object o) {
		BsonDocument result=new BsonDocument();
		Class clase = o.getClass();
		Field[] campos = clase.getDeclaredFields();
		for (Field campo : campos) {
			if (esBsonable(campo))
				add(result, campo, o);
		}
		return result;
	}

	private static void add(BsonDocument result, Field campo, Object objeto) {
		campo.setAccessible(true);
		String nombre=campo.getName();
		String tipoDelCampo = campo.getType().getName();
		try {
			if (tipoDelCampo.equals("java.lang.String")) {
				BsonString valor = new BsonString(campo.get(objeto).toString());
				result.append(nombre, valor);
			} else if (tipoDelCampo.equals("java.util.GregorianCalendar")) {
				GregorianCalendar valor=(GregorianCalendar) campo.get(objeto);
				result.append(nombre, new BsonDateTime(valor.getTimeInMillis())); 
			} else if (tipoDelCampo.equals("java.lang.Integer") || tipoDelCampo.equals("int")) {
				Integer valor=(Integer) campo.get(objeto);
				result.append(nombre, new BsonInt32(valor));
			}
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
	}

	private static boolean esBsonable(Field campo) {
		Annotation[] anotaciones = campo.getAnnotations();
		for (Annotation annotation : anotaciones) {
			if (annotation.annotationType()==Bsonable.class)
				return true;
		}
		return false;
	}

}
