package edu.uclm.esi.mongo.isotel.dominio;

import org.bson.types.ObjectId;
import org.json.simple.JSONObject;

import edu.uclm.esi.mongo.isotel.persistencia.DAOCliente;
import edu.uclm.esi.mongo.isotel.persistencia.DAOFactura;

public class Factura {
	private ObjectId _id;
	private int idCliente;
	private int numeroDeLlamadas;
	private int duracionTotal;
	private int mes;
	private int year;
	private Tarifa tarifa;

	public Factura(int idCliente, int numeroDeLlamadas, int duracionTotal, Tarifa tarifa, int mes, int year) {
		this.idCliente=idCliente;
		this.numeroDeLlamadas=numeroDeLlamadas;
		this.duracionTotal=duracionTotal;
		this.mes=mes;
		this.year=year;
		this.tarifa=tarifa;
	}

	public double getCuotaFija() {
		return this.tarifa.getCuotaFija();
	}
	
	public double getCostesEstablecimiento() {
		return this.tarifa.getEstablecimiento()*this.numeroDeLlamadas;
	}
	
	public double getCostesPorConsumo() {
		return this.tarifa.getImportePorSegundo()*this.duracionTotal;
	}
	
	public int getMes() {
		return this.mes;
	}
	
	public int getYear() {
		return this.year;
	}
	
	public Tarifa getTarifa() {
		return tarifa;
	}
	
	public Cliente getCliente() {
		Cliente cliente=new Cliente();
		DAOCliente.load(idCliente, cliente);
		return cliente;
	}
	
	public void insert() {
		DAOFactura.insert(this);
	}
}
