package edu.uclm.esi.mongo.isotel.dominio;

import java.util.Calendar;
import java.util.GregorianCalendar;

import org.bson.types.ObjectId;

import edu.uclm.esi.mongo.etiquetasMongo.Bsonable;

public class Llamada {
	@Bsonable
	private ObjectId idLlamada;
	@Bsonable
	private int idCliente;
	@Bsonable
	private String origen, destino;
	@Bsonable
	private int duracion;
	@Bsonable
	private GregorianCalendar fecha;
	
	public Llamada(ObjectId idLlamada, int idCliente, String origen,
			String destino, int duracion, GregorianCalendar fecha) {
		this.idLlamada=idLlamada;
		this.idCliente=idCliente;
		this.origen=origen;
		this.destino=destino;
		this.duracion=duracion;
		this.fecha=fecha;
	}

	public String getOrigen() {
		return origen;
	}

	public String getDestino() {
		return destino;
	}

	public int getDuracion() {
		return duracion;
	}

	public GregorianCalendar getFecha() {
		return fecha;
	}

	public double getImporte(Tarifa tarifa) {
		return tarifa.getEstablecimiento() + duracion*tarifa.getImportePorSegundo();
	}

}
