package edu.uclm.esi.mongo.isotel.persistencia;

import org.bson.BsonDocument;
import org.bson.BsonInt32;
import org.bson.BsonString;

import com.mongodb.client.MongoCollection;

import edu.uclm.esi.mongo.isotel.dominio.Tarifa;

public class DAOTarifa {
	
	public static Tarifa loadTarifa(String nombreTarifa) {
		Tarifa tarifa=null;
		try {
			Class<Tarifa> ClaseTarifa=(Class<Tarifa>) Class.forName("edu.uclm.esi.mongo.isotel.dominio." + nombreTarifa);
			tarifa = ClaseTarifa.newInstance();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return tarifa;
	}

	public static Tarifa loadTarifa(int idCliente) {
		MongoCollection<BsonDocument> colClientes=MongoBroker.get().getDB().getCollection("clientes", BsonDocument.class);
		BsonDocument criterio=new BsonDocument("_id", new BsonInt32(idCliente));
		BsonDocument bso = colClientes.find(criterio).iterator().next();
		String idTarifa=bso.get("idTarifa").asString().getValue();
		
		MongoCollection<BsonDocument> colTarifas=MongoBroker.get().getDB().getCollection("tarifas", BsonDocument.class);
		criterio=new BsonDocument("_id", new BsonString(idTarifa));
		bso = colTarifas.find(criterio).iterator().next();

		Tarifa tarifa=null;
		try {
			Class<Tarifa> ClaseTarifa=(Class<Tarifa>) Class.forName("edu.uclm.esi.mongo.isotel.dominio." + idTarifa);
			tarifa = ClaseTarifa.newInstance();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return tarifa;
	}

}
